import { FeatureName, FeatureWithEnabled } from "../../constants/contract-features";
import { AbiInput } from "../../schema/contracts/custom";
/**
 * Checks whether the given ABI supports a given feature
 * @deprecated use isExtensionEnabled instead
 * @param abi - The abi to check
 * @param featureName - The feature name to check
 * @internal
 */
export declare function isFeatureEnabled(abi: AbiInput, featureName: FeatureName, features: Record<string, FeatureWithEnabled>): boolean;
/**
 * Checks whether the given ABI supports a given extension
 * @public
 * @param abi - The abi to check
 * @param featureName - The feature name to check
 */
export declare function isExtensionEnabled(abi: AbiInput, featureName: FeatureName, features: Record<string, FeatureWithEnabled>): boolean;
//# sourceMappingURL=isFeatureEnabled.d.ts.map