import { Signer } from "zksync-ethers";
import { DeployOptions } from "../types/deploy/deploy-options";
import { PrecomputedDeploymentTransaction } from "./types/deploy-data";
import { ThirdwebStorage } from "@thirdweb-dev/storage";
/**
 * Deploy a contract at a deterministic address, using Create2 method
 * Address depends on the Create2 factory address.
 *
 * @public
 *
 * @param signer - The signer to use
 * @param bytecode - The bytecode to deploy
 * @param encodedArgs - The encoded constructor args to use
 * @param create2FactoryAddress - The create2 factory address to use
 */
export declare function zkDeployContractDeterministic(signer: Signer, transaction: PrecomputedDeploymentTransaction, storage?: ThirdwebStorage, metadataUri?: string, options?: DeployOptions, gasLimit?: number): Promise<void>;
export declare function registerContractOnMultiChainRegistry(address: string, chainId: number, metadataURI: string): Promise<boolean>;
//# sourceMappingURL=zkDeployContractDeterministic.d.ts.map